#include <cstdio>
#include <cstring>

#define Nmax 101
#define Lmax 5005
#define alfa 26

int N, M, lvl;
char S[Nmax][Lmax];
int first[Nmax][Lmax][alfa];
int st[Nmax][Lmax];

void build()
{
     int i, j, l;
     
     for (i=0; i<N; ++i)
     {
         l = strlen(S[i]) - 1;
         
         memset(first[i][l+1], -1, sizeof(first[i][l+1]));
         memset(first[i][l], -1, sizeof(first[i][l]));
         first[i][l][S[i][l]-'a'] = l;
         
         for (j=l-1; j>=0; --j)
         {
             memcpy(first[i][j], first[i][j+1], sizeof(first[i][j+1]));
             first[i][j][S[i][j]-'a'] = j;
         }
     }
     
     lvl = 0;
     for (i=0; i<N; ++i)
         st[i][0] = -1;
}

void go(char C)
{
     int i, j;
     ++lvl;
     if (lvl >= Lmax) return;
     
     for (i=0; i<N; ++i)      
     {
         if (lvl>1 && st[i][lvl-1] == -1) st[i][lvl] = -1;
            else st[i][lvl] = first[i][st[i][lvl-1]+1][C];     
     }
}

int main()
{
    int i, nr;
    char C;
    
    freopen("search.in","r",stdin);
    freopen("search.out","w",stdout);
    
    scanf("%d %d\n", &N, &M);
    for (i=0; i<N; ++i)    
        scanf("%s\n", &S[i]);    
    
    build();
    
    while (M--)
    {
          scanf("%c\n", &C);
          
          if (C != '-') go(C-'a');
             else --lvl;
          
          nr = 0;
          if (lvl < Lmax)
          for (int i=0; i<N; ++i)
          {
              if (st[i][lvl] != -1) ++nr;
          }
          printf("%d\n", nr);
    }
    
    return 0;
}
